#include "config.h"


#define _XOPEN_SOURCE		600
#define _ISOC99_SOURCE

/* Large file support */
#ifdef LARGEFILE
# define _FILE_OFFSET_BITS	64	/* POSIX large file support for fopen/fstat		*/
# define _LARGEFILE_SOURCE	1	/* Linux/xBSD/HP-UX/Solaris support for fseeko/ftello	*/
# define _LARGE_FILES 		1	/* AIX large file and fseeko/ftello support		*/
#endif


#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <locale.h>
#include <langinfo.h>
#include <errno.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <math.h>
#include <dirent.h>
#include <regex.h>


#define RECORDSIZE		9216L
#define RECORDLEN		"9215"
#define URLSIZE			8192L
#define URLLEN			"8191"
#define FILENAMESIZE		512L
#define DATETIMESIZE		128L
#define USERNAMELEN		"127"
#define USERNAMESIZE		128
#define USERDESCSIZE		256L
#define CHARSETSIZE		18
#define IPSIZE			16
#define IPLEN			"15"
#define ARGSCOUNT		32
#define CODESSIZE		1024		/* must be 1 more than required, increased for strange squid codes */
#define SAMAXTIMET		1555555555L
#define SALONGDATE		1135976400L	/* 31.12.2005 - hope it's longest date in any locale */
#define SYSLOGYEAR		2008
#define MAXLFCOUNT		16		/* to increase this value 'short int' must be replaced by 'int' */
#define MAXLFCSSCOUNT		8		/* number of classes in CSS for local filters */

#define SAHOUR			 60L * 60L
#define SADAY			 24L * SAHOUR
#define SAWEEK			  7L * SADAY
#define SAMONTH			 30L * SADAY
#define SAQUARTER		  3L * SAMONTH
#define SAYEAR			365L * SADAY

#define CMDSH			"/bin/sh"
#define CMDRM			"/bin/rm"
#define CMDMAILX		"/usr/bin/mailx"

#define SAsetbit(src, bitnr)	src |= (0x01 << bitnr)
#define SAgetbit(src, bitnr)	(src & (0x01 << bitnr))
#define SAmin(a, b)		( (a) < (b) ? (a) : (b) )
#define SAmax(a, b)		( (a) > (b) ? (a) : (b) )
#define SAnumcmp(x, y)		( (x) == (y) ? 0 : ( (x) < (y) ? 1 : -1 ) )
#define SAisxdigit(x)		(isxdigit((int)((unsigned char)(x))))
#define SADMTOSM(x)		#x
#define _(x)			SADMTOSM(x)

#if DEBUG >= 1
#	define __SAINFO__	__FILE__ ":" _(__LINE__)
#else
#	define __SAINFO__	__func__
#endif


#include "work/w_config.h"
#include "work/w_system.h"
#include "work/w_fs.h"
#include "work/w_internal.h"
#include "work/w_log_operations.h"
#include "work/w_svg.h"

#include "reports/r_efficiency.h"
#include "reports/r_users.h"
#include "reports/r_topsites.h"
#include "reports/r_topuser.h"
#include "reports/r_localfilter.h"
#include "reports/r_usergraphs.h"
#include "reports/r_userdatetime.h"
#include "reports/r_email.h"
#include "reports/r_reports.h"
#include "reports/r_list.h"
#include "reports/r_index.h"

#include "logformats/l_squid_native.h"
#include "logformats/l_clf_native.h"
#include "logformats/l_combined_native.h"
#include "logformats/l_postfix_syslog.h"
#include "logformats/l_qmail_syslog.h"
#include "logformats/l_cgp_native.h"
#include "logformats/l_logformats.h"
