#define SYSLOGDTSIZE	16
#define SYSLOGDTLEN	"15"

#define PROXY		1
#define WWW		2
#define FTP		3
#define MAIL		4
#define FIREWALL	5


typedef struct LogFormat {
    const char *name;
    struct MailRecord *(* ReadRecordM)(FILE *iLog);
    char (* ReadRecord)(FILE *Log, time_t *ttime, double *tSeconds, char *tip, short int *tcode, double *tBytes, char *tmethod, char *turl, char *tname, char *tstat);
    char (* ReadDT)(FILE *Log, time_t *ttime);
    char (* ReadFullDT)(FILE *Log, time_t *ttime, char *tbuf);
    void (* ReadAlign)(FILE *Log);
    char isLinear;
    char Class;
} LogFormat;

typedef struct MailRecord {
    unsigned int		msgid;
    double			bytes;
    time_t			time;
    struct MailRecord		*next;
    short int			code;
    char			ip[IPSIZE];
    char			url[URLSIZE];
    char			name[USERNAMESIZE];
    char			status;
    char			stat;
    char			count;
} MailRecord;


extern struct LogFormat LogFormats[6];
extern struct MailRecord *sMR;


extern void CommonReadAlign(FILE *iLog);
extern void CLFDTZ(time_t *iTime, char *idt);
extern char CLFReadDT(FILE *iLog, time_t *iTime);
extern char CLFReadFullDT(FILE *iLog, time_t *iTime, char *iBuf);
extern void SyslogDTZ(time_t *iTime, char *idt, short int year);
extern char SyslogReadDT(FILE *iLog, time_t *iTime);
extern char SyslogReadFullDT(FILE *iLog, time_t *iTime, char *iBuf);
extern char MailReadRecord(FILE *tLog, time_t *tTime, double *tSeconds, char *tIp, short int *tCode, double *tBytes, char *tMethod, char *tUrl, char *tName, char *tStat);
extern struct MailRecord *FindNewMR(unsigned int msgid);
extern struct MailRecord *FindDupMR(unsigned int msgid);
extern struct MailRecord *FindMRbyCode(short int icode);
extern void DelMRs(unsigned int msgid);
extern void DelMR(struct MailRecord *iMR);
