#include "global.h"


char SquidReadRecord(FILE *Log, time_t *ttime, double *tseconds, char *tip, short int *tcode, double *tbytes, char *tmethod, char *turl, char *tname, char *tstat) {
    char sqresstr[40] = "\000", sqstat;

    if (fscanf(Log, "%10ld.%*3c %lf %" IPLEN "s %39[^/]/%3hd %lf %c%*s %" URLLEN "s %" USERNAMELEN "s %*[^/]/%c%*[^\n]%*c", ttime, tseconds, tip, sqresstr, tcode, tbytes, tmethod, turl, tname, &sqstat) != 10) return 0;
    
    /* Denied (D):
	4: TCP_DENIED, UDP_DENIED
       Cached (H):
    	4: UDP_HIT, TCP_HIT
	8: TCP_MEM_HIT, TCP_IMS_HIT
	12: TCP_OFFLINE_HIT, TCP_REFRESH_HIT (actually have traffic and 'H' at 10, omit it)
	13: TCP_NEGATIVE_HIT, TCP_REF_FAIL_HIT	*/
    
    if (sqstat == '-') {
	if (sqresstr[4] == 'D' && *tcode == 403) *tstat = 1;	/* denied */
	else switch (strchr(&sqresstr[4], 'H') - sqresstr) {
	    case 4:
	    case 8:
	    case 12:
	    case 13:
	    	    *tstat = 2;					/* cached */
	    	    break;
	    default:
	    	    *tstat = 3;					/* other  */
	    	    break;
	}
    } else *tstat = 0;						/* actual */
    
    return 1;
}


char SquidReadDT(FILE *Log, time_t *ttime) {
    return (fscanf(Log, "%10ld%*[^\n]%*c", ttime) == 1) ? 1 : 0;
}


char SquidReadFullDT(FILE *Log, time_t *ttime, char *tbuf) {
    if (fscanf(Log, "%" RECORDLEN "[^\n]%*c", tbuf) != 1) return 0;
    if (sscanf(tbuf, "%10ld", ttime) != 1) return 0;
    
    return 1;
}
