#include "global.h"


struct LFreport LF[MAXLFCOUNT];


void ReportLocalFilter(void) {
    FILE *LFR;
    short int i, tIndic;
    time_t tTime;
    double tBytes;
    char turl[URLSIZE], tname[USERNAMESIZE], otname[USERNAMESIZE], tfname[FILENAMESIZE];
    struct SAentry *res = NULL;


    for (i = 0; i < icfg.LFcount; i++) {
        /* LF_UNS: close */
        SAfclose(LF[i].file);

        /* LF: sort and generate report only if there is records */
        if (LF[i].all.count) {
	    strcpy(tfname, LF[i].fname);
	    tfname[strlen(tfname) - 4L] = '\0';
	
	    /* LF_UNS: sort by name(reverse) and datetime(normal,numeric) */
	    SAsystem(CMDSORT, CMDSORT, "-k", "1,1r", "-k", "2,2n", "-o", tfname, LF[i].fname, NULL);
	    /* LF_UNS: delete */
	    SAunlink(LF[i].fname);
		
	    /* LF_SRT: open */
	    LF[i].file = SAfopenI("r", tfname);
	    /* LFR: open */
	    LFR = SAfopenH("../", 'l', lfcfgs[i]->name, rcfg.LFRsort, 1, "%s/lf_%hd.html", icfg.ReportDir, i);
		
	    /* LFR: write main table header */
	    SAfprintf(LFR, "\t<tr><th>%s<th>%s%s%s<th>%s\n", loc->User, loc->DnT, (lfcfgs[i]->showbytes) ? "<th>" : "", (lfcfgs[i]->showbytes) ? loc->Bytes : "", loc->URL);
	    
	    if (lfcfgs[i]->showbytes) {
	        /* LFR: write user stats */
	        otname[0] = '\0';
	        while(fscanf(LF[i].file, "%s %ld %s %lf %hd\n", tname, &tTime, turl, &tBytes, &tIndic) == 5) {
		    if (strcmp(otname, tname)) {
			if (otname[0] != '\0') SAfwrite1("<tr><td class=el>\n", 18L, LFR);
		        strcpy(otname, tname);
    		        res = SAentryByName(tname);
		    } else tname[0] = '\0';
			
		    SAfprintf(LFR, "<tr><td>%s<td>%s<td class=rt>%s<td><a href=\"%s\">%s</a>", (tname[0] == '\0') ? "" : res->vname, GetDT(tTime, "%x&nbsp;%X"), icfg.SAB(tBytes), turl, LimitedURL(turl));
		    Indics(LFR, tIndic);
		}
	    } else {
		/* LFR: write user stats */
		otname[0] = '\0';
		while(fscanf(LF[i].file, "%s %ld %s %hd\n", tname, &tTime, turl, &tIndic) == 4) {
		    if (strcmp(otname, tname)) {
			if (otname[0] != '\0') SAfwrite1("<tr><td class=el>\n", 18L, LFR);
		        strcpy(otname, tname);
    		        res = SAentryByName(tname);
		    } else tname[0] = '\0';
		
		    SAfprintf(LFR, "<tr><td>%s<td>%s<td><a href=\"%s\">%s</a>", (tname[0] == '\0') ? "" : res->vname, GetDT(tTime, "%x&nbsp;%X"), turl, LimitedURL(turl));
		    Indics(LFR, tIndic);
		}
	    }
		
	    /* LFR: close */
    	    SAfcloseH(LFR);
		
	    /* LF_SRT: close and delete */
	    SAfcloseU(LF[i].file, tfname);
	} else SAunlink(LF[i].fname); /* LF_UNS: delete */
    } 
}
