#include "global.h"


void InitReports(void) {
    short int i;
    char sortorder[URLSIZE];


    /* Clear temporary directory */
    SArm("%s/*", cfg.cache_directory);
    
    /* LF_UNS: open */
    for (i = 0; i < icfg.LFcount; i++) {
    	SAsnprintf(LF[i].fname, sizeof(LF[i].fname), TEMPL_LF_UNS, cfg.cache_directory, i);
	LF[i].file = SAfopenI("w", LF[i].fname);
	LF[i].all.count = 0;
    }

    /* Replace localisation strings */
    if (LogFormats[cfg.log_format].Class == MAIL) {
	loc->User = loc->Sender;
	loc->Connections = loc->Messages;
	loc->URL = loc->Recipient;
	loc->Users = loc->Senders;
	loc->TopUser = loc->Senders;
	loc->TopSites = loc->Recipients;
    }

    /* Fill reports sorting description, so we will not do this many times for UFR, UR, UDR and LFR */
    SAsnprintf(sortorder, sizeof(sortorder), "%s, %s (%s, %s)", loc->URL, loc->DnT, loc->Asc, loc->Asc);
    rcfg.UFRsort = SAstrdup(sortorder);
    SAsnprintf(sortorder, sizeof(sortorder), "%s (%s)", loc->Bytes, loc->Desc);
    rcfg.URsort = SAstrdup(sortorder);
    SAsnprintf(sortorder, sizeof(sortorder), "%s (%s)", loc->DsT, loc->Asc);
    rcfg.UDRsort = SAstrdup(sortorder);
    SAsnprintf(sortorder, sizeof(sortorder), "%s, %s (%s, %s)", loc->User, loc->DnT, loc->Desc, loc->Asc);
    rcfg.LFRsort = SAstrdup(sortorder);

    /* Clear efficiency data */
    if (cfg.server_efficiency_report) memset(ec, 0, sizeof(ec));
}


void GenerateReports(void) {
    short int i, j;
    char tfname[FILENAMESIZE];
    FILE *DF;


    /* Create reports directory */
    j = SAsnprintf(tfname, sizeof(tfname), "%s/%s-", cfg.target_directory, icfg.Period);
    FixFileName(&tfname[j - strlen(icfg.Period)]);
    
    for (i = 1; ; i++) {
	SAsnprintf(&tfname[j], sizeof(tfname) - j, "%hd", i);
	if (mkdir(tfname, 0755)) {
	    if (errno != EEXIST) SAexit("%s. %s", tfname, strerror(errno));
	} else break;
    }
    
    /* Save reports directory */
    icfg.ReportDir = SAstrdup(tfname);

    ReportLocalFilter();
    ReportTopUser();
    if (cfg.users_report || cfg.top_sites_report) ReportUsers();
    if (cfg.email_address != NULL) ReportEmail();
    if (cfg.top_sites_report) ReportTopSites();
    if (cfg.server_efficiency_report) ReportProxyEfficiency();
    ReportList();

    /* DF: all */
    DF = SAfopen("w", "%s/%s", icfg.ReportDir, icfg.DFname);
    SAfprintf(DF, "%ld %ld\n%s\n%.0f\n%d\n", icfg.SDate, icfg.EDate, cfg.configuration_name, all[0].bytes, ccueCount);
    SAfclose(DF);

    ReportIndex();
}
